<?php

function cck_sm_requirements() {
	if (function_exists('content_copy_types')) return;
	drush_die('You should enable the content_copy module first');
}

function cck_sm_options() {
  return array(
  );
}

function cck_sm_arguments() {
  return array(
    'list' => array(
    ),
    'export' => array(
      '- | dir-name' => 'stdout or directory',
    ),
  );     
}

function cck_sm_list() {
	cck_sm_requirements();
	
  $args = func_get_args();
  $content_types=content_copy_types();
  foreach ($content_types as $content_type => $item) {
    echo "$content_type\n";
    $fields = content_copy_fields($content_type);
    foreach ($fields as $field) {
      echo "  $field\n";
    }
  }
}

function cck_sm_export() {
  cck_sm_requirements();

	$args = func_get_args();
  $dir=array_shift($args);
  if (count($args)) {
    drush_die( "Too many arguments.");
  }
  require_once './includes/common.inc';
  module_load_include('inc', 'node', 'content_types');
  $content_types=content_copy_types();
  ksort($content_types);
  foreach ($content_types as $type_name => $item) {
    $node_state = array('values' => array('type_name' => $type_name));
    drupal_execute('node_type_form', $node_state, node_get_types('type', $type_name));
    $code= "\n" . '$content_types["' . $type_name .'"]=';
    $code .= "\n" . var_export($node_state, TRUE) . ";";
    if (is_dir($dir)) {
      // patch for ad module with has names like ad/image :(
      $type_name = str_replace("/", "_", $type_name);
      $file=realpath($dir) . '/' . $type_name . '.txt';
      if (drush_get_context('DRUSH_SIMULATE')) {
        drush_log( "Should write to file $file");
      }
      else {
        drush_log( "Writing file $file");
        $result=file_put_contents( $file, $code . "\n");
        if ($result===FALSE) {
          drush_die('Cannot write to ' . $file);
        }
      }
    }
    else if ($dir=='-') {
      echo $code;
    }
    else {
      drush_die( "'$dir' is not a directory. Use '-' or an existing directory", 2);
    }
  }
  module_load_include('inc', 'content', 'includes/content.admin');
  module_load_include('inc', 'content', 'includes/content.crud');
  $content_fields=content_field_instance_read();
  foreach ($content_fields as $def) {
    $field_name= 'cck_' . $def['type_name'] . '_' . $def['field_name'];
    $code='$content_fields["' . $def['type_name'] . '"]["'. $def['field_name'] . '"]=' . "\n";
    $code .= var_export( $def, TRUE) . ";\n";
    if (is_dir($dir)) {
      $file= realpath($dir) . '/' . $field_name . '.txt';
      if (drush_get_context('DRUSH_SIMULATE')) {
        drush_log( "Should write to file $file");
      }
      else {
        drush_log( "Writing file $file");
        $result=file_put_contents( $file, $code . "\n");
        if ($result===FALSE) {
          drush_die('nop');
        }
      }
    }
    else if ($dir=='-') {
      echo $code;
    }
    else {
      drush_die( "'$dir' is not a directory. Use '-' or an existing directory", 2);
    }
  }
}
