<?php

function variables_sm_options() {
  return array(
  );
}

function variables_sm_arguments() {
  return array(
    'list' => array(
      'var-name(s) | part-of-var-name(s)' => 'variable name(s) or part of a variable name',
    ),
    'export' => array(
      '- | dir-name' => 'stdout or directory',
      'var-name(s) | part-of-var-name(s)' => 'variable name(s) or part of a variable name',
    ),
    'import' => array(
      '- | dir-name' => 'stdout or directory',
    ),
    'report' => array(
      'var-name(s) | part-of-var-name(s)' => 'variable name(s) or part of a variable name',
    ),
  );     
}

/**
 * Implementation of _sm_list
 *
 */
function variables_sm_list() {
  $args = func_get_args();
  drush_log(implode(', ', $args));
  drush_log("Listing ... ");
  $report=_variables_sm_sql($args);
  ksort($report);
  foreach ($report as $name=>$value) {
    echo "$name\n";
  }
}

function variables_sm_import() {
  $args = func_get_args();
  drush_log(implode(', ', $args));
  $dir=array_shift($args);
  $file= $dir . '/variables.txt';
  drush_log( "Using $file");
  if (is_file($file)) {
    /* import fails due to stdObject::__setState call for language settings :(
    $o=(object) array('a'=>'b');
    $o->__setState(array('b'=>'c'));
    */
    $result = eval( 'return $x=' . file_get_contents($file) . ';');
    if (is_array($result)) {
      drush_log( "Setting variables");
      
      foreach( $result as $key => $value) {
        $old=variable_get($key);
        drush_log( (isset($old) || is_null($value) ? 'overriding ' : 'adding ') . $key);
        if (!drush_get_context('DRUSH_SIMULATE')) {
          variable_set( $key, $value);
        }
      }
    }
    else {
      drush_die( "Unexpected result from contents of $file", 2);
    }
  }
  else {
    drush_die( "$file does not exists.", 2);
  }
}

function variables_sm_export() {
  $args = func_get_args();
  drush_log(implode(', ', $args));
  $dir=array_shift($args);
  $report=_variables_sm_sql($args);
  $code= var_export($report, TRUE);
  if ($dir) {
    if (is_dir($dir)) {
      drush_log( "Directory $dir");
      $file = $dir . "/" . 'variables.txt';
      file_put_contents($file, $code);
    }
    else if ($dir=='-') {
      drush_log( "stdout");
      print $code . "\n";
    }
    else {
      drush_die( "'$dir' is not a directory.", 2);
    }
  }
  else {
    drush_die( "You must give either a directory or stdout '-'.", 2);
  }
}

function variables_sm_report() {
  $args = func_get_args();
  drush_log(implode(', ', $args));
  drush_log( "Reporting ...");
  $report=_variables_sm_sql($args);
  $nothing_to_report=TRUE;
  foreach ($report as $name => $value) {
    $var_get=variable_get($name);
    if (!isset($var_get) || $var_get !== $value) {
      $nothing_to_report=FALSE;
      echo $name . " overridden by " . var_export($var_get, TRUE) ."\n";
    }
  }
  if ($nothing_to_report) {
    drush_log("Nothing to report.", 'ok');
  }
}

function _variables_sm_sql($args=array()) {
  $options=drush_get_context('options');
  $sql= "select * from {variable} order by name";
  $result=db_query($sql);
  $return=array();
  while ($record = db_fetch_array($result)) {
    $name = $record['name'];
    $value=unserialize($record['value']);
    $part_match=FALSE;
    foreach ($args as $arg) {
      if (strpos($name, $arg)!== FALSE) {
        $part_match=TRUE;
        break;
      }
    }
    if (!count($args) || in_array($name, $args) || $part_match) {
      $return[$name]=$value;
    }
    else {
      drush_log(".. skipping $name");
    }
  }
  return $return;
} 
